/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

#ifdef ENABLE_CHECKING
  memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
  memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
#endif

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 538:
    case 537:
    case 536:
    case 535:
    case 534:
    case 533:
    case 532:
    case 531:
    case 530:
    case 529:
    case 528:
    case 527:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 343:  /* *extzv.qihi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 342:  /* *extzv.qihi1 */
    case 341:  /* *extzv */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 340:  /* *iorsiqi.byte1-3 */
    case 339:  /* *xorsiqi.byte1-3 */
    case 338:  /* *iorpsiqi.byte1-3 */
    case 337:  /* *xorpsiqi.byte1-3 */
    case 336:  /* *iorhiqi.byte1-3 */
    case 335:  /* *xorhiqi.byte1-3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 328:  /* *insv.reg */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 327:  /* *insv.not.io */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 326:  /* *insv.io */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 2));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 324:  /* *movbitqi.0 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 323:  /* *movbitqi.1-6.b */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 322:  /* *movbitqi.1-6.a */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 313:  /* nopv */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 297:  /* *parityqihi2 */
    case 296:  /* *parityhi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 294:  /* insert_bits */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 293:  /* delay_cycles_4 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 292:  /* delay_cycles_3 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 291:  /* delay_cycles_2 */
    case 290:  /* delay_cycles_1 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 285:  /* epilogue_restores */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 284:  /* call_prologue_saves */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 2), 1), 1));
      break;

    case 281:  /* popqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 280:  /* *sbix_branch_tmp_bit7 */
    case 277:  /* *sbix_branch_bit7 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 279:  /* *sbix_branch_tmp */
    case 278:  /* *sbix_branch_tmp */
    case 276:  /* *sbix_branch */
    case 275:  /* *sbix_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 274:  /* *sbi */
    case 273:  /* *cbi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 271:  /* *tablejump */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 2), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 267:  /* call_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 266:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 265:  /* difficult_rvbranch */
    case 264:  /* rvbranch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 262:  /* branch_unspec */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      break;

    case 263:  /* difficult_branch */
    case 261:  /* branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 260:  /* *sbrx_and_branchsi */
    case 259:  /* *sbrx_and_branchpsi */
    case 258:  /* *sbrx_and_branchhi */
    case 257:  /* *sbrx_and_branchqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 256:  /* *sbrx_branchdi */
    case 255:  /* *sbrx_branchsi */
    case 254:  /* *sbrx_branchpsi */
    case 253:  /* *sbrx_branchhi */
    case 252:  /* *sbrx_branchqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 251:  /* *cmpsi */
    case 250:  /* *cmppsi */
    case 249:  /* *cmphi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 248:  /* *cmpqi_sign_extend */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 247:  /* *cmpqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 351:  /* compare_const_di2 */
    case 246:  /* *reversed_tstsi */
    case 244:  /* *reversed_tstpsi */
    case 242:  /* *reversed_tsthi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 346:  /* adddi3_const_insn */
    case 240:  /* *reversed_tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 245:  /* *negated_tstsi */
    case 243:  /* *negated_tstpsi */
    case 241:  /* *negated_tsthi */
    case 239:  /* *negated_tstqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 295:  /* *split.flash_segment */
    case 194:  /* *ashlhiqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 193:  /* *ashluqihiqi3.mem */
    case 192:  /* *ashlsqihiqi3.mem */
    case 191:  /* *ashluqihiqi3 */
    case 190:  /* *ashlsqihiqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 238:  /* zero_extendsidi2 */
    case 237:  /* zero_extendhidi2 */
    case 236:  /* zero_extendqidi2 */
    case 235:  /* zero_extendpsisi2 */
    case 234:  /* zero_extendhisi2 */
    case 232:  /* zero_extendhipsi2 */
    case 231:  /* zero_extendqisi2 */
    case 230:  /* zero_extendqipsi2 */
    case 229:  /* zero_extendqihi2 */
    case 228:  /* extendpsisi2 */
    case 227:  /* extendhisi2 */
    case 226:  /* extendhipsi2 */
    case 225:  /* extendqisi2 */
    case 224:  /* extendqipsi2 */
    case 223:  /* extendqihi2 */
    case 222:  /* one_cmplsi2 */
    case 221:  /* one_cmplpsi2 */
    case 220:  /* one_cmplhi2 */
    case 219:  /* one_cmplqi2 */
    case 218:  /* negsf2 */
    case 217:  /* negsi2 */
    case 216:  /* negpsi2 */
    case 215:  /* neghi2 */
    case 213:  /* negqi2 */
    case 212:  /* abssf2 */
    case 211:  /* absqi2 */
    case 181:  /* *rotlsi2.31 */
    case 180:  /* *rotlsi2.1 */
    case 179:  /* *rotlpsi2.23 */
    case 178:  /* *rotlpsi2.1 */
    case 177:  /* *rotlhi2.15 */
    case 176:  /* *rotlhi2.1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 150:  /* *umulhiqipsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 161:  /* udivmodsi4 */
    case 159:  /* divmodsi4 */
    case 157:  /* udivmodpsi4 */
    case 155:  /* divmodpsi4 */
    case 147:  /* udivmodhi4 */
    case 145:  /* divmodhi4 */
    case 143:  /* udivmodqi4 */
    case 141:  /* divmodqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 131:  /* *uumulhihisi3 */
    case 130:  /* *sumulhihisi3 */
    case 129:  /* *usmulhihisi3 */
    case 128:  /* *ssmulhihisi3 */
    case 127:  /* *uumulqihisi3 */
    case 126:  /* *sumulqihisi3 */
    case 125:  /* *usmulqihisi3 */
    case 124:  /* *ssmulqihisi3 */
    case 123:  /* *uumulhiqisi3 */
    case 122:  /* *sumulhiqisi3 */
    case 121:  /* *usmulhiqisi3 */
    case 120:  /* *ssmulhiqisi3 */
    case 119:  /* *uumulqiqisi3 */
    case 118:  /* *sumulqiqisi3 */
    case 117:  /* *usmulqiqisi3 */
    case 116:  /* *ssmulqiqisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 115:  /* mulohisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 151:  /* mulsqipsi3 */
    case 114:  /* mulshisi3 */
    case 113:  /* mulsqisi3 */
    case 112:  /* muluhisi3 */
    case 111:  /* muluqisi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 152:  /* *mulpsi3 */
    case 110:  /* *mulsi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 107:  /* muloqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 103:  /* *ashifthi3.signx.const7 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 95:  /* *sumsubqihi4.uconst */
    case 93:  /* *msubqihi4.sconst.ashift */
    case 92:  /* *umsubqihi4.uconst.ashift */
    case 91:  /* *umsubqihi4.uconst */
    case 90:  /* *msubqihi4.sconst */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 94:  /* *sumaddqihi4.uconst */
    case 89:  /* *umaddqihi4.uconst */
    case 88:  /* *maddqihi4.sconst */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 87:  /* *sumsubqihi4 */
    case 86:  /* *usmsubqihi4 */
    case 83:  /* *umsubqihi4 */
    case 82:  /* *msubqihi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 85:  /* *sumsubqihi4 */
    case 84:  /* *usmsubqihi4 */
    case 81:  /* *umaddqihi4 */
    case 80:  /* *maddqihi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 79:  /* *msubqi4.const */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 78:  /* *maddqi4.const */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 77:  /* *msubqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 76:  /* *maddqi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 75:  /* *oumulqihi3 */
    case 74:  /* *osmulqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 325:  /* *movbitqi.7 */
    case 149:  /* *umulqihipsi3 */
    case 73:  /* *sumulqihi3 */
    case 72:  /* usmulqihi3 */
    case 71:  /* umulqihi3 */
    case 70:  /* mulqihi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 268:  /* call_value_insn */
    case 104:  /* *ashifthi3.zerox.const */
    case 102:  /* *ashifthi3.signx.const */
    case 100:  /* *mulsqihi3.oconst */
    case 99:  /* *mulsqihi3.uconst */
    case 98:  /* *muluqihi3.sconst */
    case 97:  /* *muluqihi3.uconst */
    case 96:  /* *mulsqihi3.sconst */
    case 67:  /* *addhi3.lt0 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 64:  /* umulqi3_highpart */
    case 63:  /* smulqi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 233:  /* n_extendhipsi2 */
    case 210:  /* *lshrsi3_const */
    case 209:  /* *lshrhi3_const */
    case 207:  /* lshrpsi3 */
    case 204:  /* *ashrsi3_const */
    case 203:  /* *ashrhi3_const */
    case 201:  /* ashrpsi3 */
    case 198:  /* *ashlpsi3 */
    case 197:  /* *ashlsi3_const */
    case 196:  /* *ashlhi3_const */
    case 187:  /* *rotbsi */
    case 186:  /* *rotbpsi */
    case 185:  /* *rotbhi */
    case 184:  /* *rotwsi */
    case 183:  /* *rotwpsi */
    case 182:  /* *rotwhi */
    case 174:  /* xorsi3 */
    case 173:  /* xorpsi3 */
    case 172:  /* xorhi3 */
    case 170:  /* iorsi3 */
    case 169:  /* iorpsi3 */
    case 168:  /* iorhi3 */
    case 166:  /* andsi3 */
    case 165:  /* andpsi3 */
    case 164:  /* andhi3 */
    case 49:  /* addpsi3 */
    case 43:  /* addsi3 */
    case 42:  /* addhi3_clobber */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 40:  /* *addhi3_sp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 65:  /* *subqi3.ashiftrt7 */
    case 60:  /* *subsi3_zero_extend.hi */
    case 59:  /* *subsi3_zero_extend */
    case 57:  /* *subhi3.sign_extend2 */
    case 56:  /* *subhi3_zero_extend1 */
    case 53:  /* *subpsi3_sign_extend.hi */
    case 52:  /* *subpsi3_zero_extend.hi */
    case 51:  /* *subpsi3_zero_extend.qi */
    case 38:  /* *addhi3_zero_extend1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 334:  /* *iorsiqi.byte0 */
    case 333:  /* *xorsiqi.byte0 */
    case 332:  /* *iorpsiqi.byte0 */
    case 331:  /* *xorpsiqi.byte0 */
    case 330:  /* *iorhiqi.byte0 */
    case 329:  /* *xorhiqi.byte0 */
    case 106:  /* muluqihi3 */
    case 105:  /* mulsqihi3 */
    case 69:  /* *addsi3.lt0 */
    case 68:  /* *addpsi3.lt0 */
    case 66:  /* *addqi3.lt0 */
    case 48:  /* *addsi3_zero_extend.hi */
    case 47:  /* *addsi3_zero_extend */
    case 46:  /* *addpsi3_sign_extend.hi */
    case 45:  /* *addpsi3_zero_extend.hi */
    case 44:  /* *addpsi3_zero_extend.qi */
    case 39:  /* *addhi3.sign_extend1 */
    case 37:  /* *addhi3_zero_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 208:  /* lshrsi3 */
    case 206:  /* lshrhi3 */
    case 205:  /* *lshrqi3 */
    case 202:  /* ashrsi3 */
    case 200:  /* ashrhi3 */
    case 199:  /* ashrqi3 */
    case 195:  /* ashlsi3 */
    case 189:  /* ashlhi3 */
    case 188:  /* *ashlqi3 */
    case 175:  /* *rotlqi3 */
    case 171:  /* xorqi3 */
    case 167:  /* iorqi3 */
    case 163:  /* andqi3 */
    case 108:  /* *mulhi3_enh */
    case 61:  /* *mulqi3_enh */
    case 58:  /* subsi3 */
    case 55:  /* subhi3 */
    case 54:  /* subqi3 */
    case 50:  /* subpsi3 */
    case 41:  /* *addhi3 */
    case 36:  /* addqi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 35:  /* *strlenhi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 34:  /* *clrmemhi */
    case 33:  /* *clrmemqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 32:  /* movmemx_hi */
    case 31:  /* movmemx_qi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 8), 0), 0));
      break;

    case 30:  /* movmem_hi */
    case 29:  /* movmem_qi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 6), 0));
      break;

    case 320:  /* fmulsu_insn */
    case 318:  /* fmuls_insn */
    case 316:  /* fmul_insn */
    case 311:  /* copysignsf3 */
    case 20:  /* movhi_sp_r */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 28:  /* *reload_insf */
    case 25:  /* *reload_insi */
    case 23:  /* *reload_inpsi */
    case 21:  /* *reload_inhi */
    case 19:  /* *reload_inqi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 27:  /* *movsf */
    case 26:  /* *movsi */
    case 24:  /* *movpsi */
    case 22:  /* *movhi */
    case 18:  /* movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 355:  /* rotldi3_insn */
    case 354:  /* lshrdi3_insn */
    case 353:  /* ashrdi3_insn */
    case 352:  /* ashldi3_insn */
    case 350:  /* compare_const8_di2 */
    case 349:  /* compare_di2 */
    case 348:  /* negdi2_insn */
    case 347:  /* subdi3_insn */
    case 345:  /* adddi3_const8_insn */
    case 344:  /* adddi3_insn */
    case 321:  /* *fmulsu.call */
    case 319:  /* *fmuls.call */
    case 317:  /* *fmul.call */
    case 315:  /* wdr */
    case 314:  /* sleep */
    case 312:  /* *bswapsi2.libgcc */
    case 310:  /* *ffssihi2.libgcc */
    case 309:  /* *ffshi2.libgcc */
    case 308:  /* *ctzsihi2.libgcc */
    case 307:  /* *ctzhi2.libgcc */
    case 306:  /* *clzsihi2.libgcc */
    case 305:  /* *clzhi2.libgcc */
    case 304:  /* *popcountqihi2.libgcc */
    case 303:  /* *popcountqi2.libgcc */
    case 302:  /* *popcountsi2.libgcc */
    case 301:  /* *popcounthi2.libgcc */
    case 300:  /* *paritysihi2.libgcc */
    case 299:  /* *parityqihi2.libgcc */
    case 298:  /* *parityhi2.libgcc */
    case 289:  /* return_from_naked_epilogue */
    case 288:  /* return_from_interrupt_epilogue */
    case 287:  /* return_from_epilogue */
    case 286:  /* return */
    case 283:  /* disable_interrupt */
    case 282:  /* enable_interrupt */
    case 272:  /* sez */
    case 269:  /* nop */
    case 162:  /* *udivmodsi4_call */
    case 160:  /* *divmodsi4_call */
    case 158:  /* *udivmodpsi4_call */
    case 156:  /* *divmodpsi4_call */
    case 154:  /* *mulpsi3.libgcc */
    case 153:  /* *mulsqipsi3.libgcc */
    case 148:  /* *udivmodhi4_call */
    case 146:  /* *divmodhi4_call */
    case 144:  /* *udivmodqi4_call */
    case 142:  /* *divmodqi4_call */
    case 140:  /* *mulohisi3_call */
    case 139:  /* *muluhisi3_call */
    case 138:  /* *mulshisi3_call */
    case 137:  /* *usmulhisi3_call */
    case 136:  /* *umulhi3_highpart_call */
    case 135:  /* *smulhi3_highpart_call */
    case 134:  /* *umulhisi3_call */
    case 133:  /* *mulhisi3_call */
    case 132:  /* *mulsi3_call */
    case 109:  /* *mulhi3_call */
    case 62:  /* *mulqi3_call */
    case 17:  /* xload_psi_libgcc */
    case 16:  /* xload_sf_libgcc */
    case 15:  /* xload_si_libgcc */
    case 14:  /* xload_hi_libgcc */
    case 13:  /* xload_qi_libgcc */
      break;

    case 214:  /* *negqihi2 */
    case 101:  /* *ashiftqihi2.signx.1 */
    case 12:  /* xload_8 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 11:  /* xloadpsi_A */
    case 10:  /* xloadsf_A */
    case 9:  /* xloadsi_A */
    case 8:  /* xloadhi_A */
    case 7:  /* xloadqi_A */
    case 6:  /* xload8_A */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 270:  /* *indirect_jump */
    case 5:  /* load_psi_libgcc */
    case 4:  /* load_sf_libgcc */
    case 3:  /* load_si_libgcc */
    case 2:  /* load_hi_libgcc */
    case 1:  /* load_qi_libgcc */
    case 0:  /* pushqi1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    }
}
